<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      groupsData: { visible: false, groups: [] },
      currentHash: '',
    };
  },
  computed: {
    hiddenGroups(): boolean {
      return this.groupsData.groups.some((group: any) => !group.visible);
    },
    hashChanged(): boolean {
      return this.$route.hash !== this.currentHash;
    },
  },
  watch: {
    $route({ hash }): void {
      this.openQuestionFromHash(hash);
    },
  },
  mounted() {
    this.groupsData.groups = this.data.groups.map(
      (group: any, groupIndex: number) => ({
        ...group,
        visible: !groupIndex,
        questions: group.questions.map((item: any) => ({
          ...item,
          expanded: false,
          id: this.parseToKebabCase(item.question),
        })),
      }),
    );
  },
  updated() {
    if (this.hashChanged) {
      this.currentHash = this.$route.hash;
      this.openQuestionFromHash(this.$route.hash);
    }
  },
  methods: {
    toggleGroup(groupIndex: number, newState: boolean): void {
      const selectedGroup = this.groupsData.groups[groupIndex] as any;
      selectedGroup.questions = selectedGroup.questions.map(
        (question: any) => ({
          ...question,
          expanded: newState,
        }),
      );
    },
    openQuestionFromHash(hash: string) {
      const id = hash.replace('#', '');

      if (this.$refs[id] as any[0]) {
        const [groupIndex, questionIndex] = (this.$refs[id] as any)[0].$el
          .getAttribute('data-anchor-index')
          .split(',');
        this.groupsData.visible = true;
        (this.groupsData.groups[groupIndex] as any).questions[
          questionIndex
        ].expanded = true;
      }
    },
    toggleQuestion(groupIndex: number, questionIndex: number) {
      const selectedQuestion = (this.groupsData.groups[groupIndex] as any)
        .questions[questionIndex];
      selectedQuestion.expanded = !selectedQuestion.expanded;
    },
    getShowAll(group: any) {
      return group.questions.some((question: any) => !question.expanded);
    },
    parseToKebabCase(string: string) {
      return string
        .toLowerCase()
        .replaceAll('?', '')
        .replace(/[&/\\#,+()$~%.'":*?<>{}\s]/g, '-');
    },
    toggleSectionVisibility() {
      this.groupsData.visible = !this.groupsData.visible;
    },
  },
});
</script>

<template>
  <SlpContainer
    class="slp-faq"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
  >
    <span
      v-if="data.metadata"
      :id="data.metadata.id_tag || ''"
      :data-slippers-scroll="data.metadata.id_tag || ''"
    ></span>
    <div class="faq__title">
      <SlpTypography tag="h2" variant="heading2-bold">{{
        data.header
      }}</SlpTypography>
    </div>
    <div class="faq">
      <div
        v-for="(group, groupIndex) in groupsData.groups"
        v-show="groupsData.visible || !groupIndex"
        :key="group.header"
        class="faq__container"
      >
        <div
          class="faq__wrapper"
          :class="{ 'faq--double-column': data.double_column }"
        >
          <div v-if="group.header" aria-live="polite" class="faq__group-header">
            <SlpTypography tag="h3" variant="heading4" class="faq__header">{{
              group.header
            }}</SlpTypography>
            <button
              v-if="getShowAll(group)"
              type="button"
              class="action"
              :data-toggle-group="group.header"
              @click="toggleGroup(groupIndex, true)"
            >
              <SlpTypography
                class="group-control"
                variant="body2"
                role="button"
                :aria-label="`Expand all ${group.header} items.`"
              >
                Show All
              </SlpTypography>
            </button>
            <button
              v-else
              type="button"
              tabindex="0"
              :aria-label="`Close all ${group.header} items.`"
              class="action"
              @click="toggleGroup(groupIndex, false)"
            >
              <SlpTypography class="group-control" variant="body2">
                Hide All
              </SlpTypography>
            </button>
          </div>
          <div
            v-for="(item, questionIndex) in group.questions"
            :key="`question-${groupIndex}-${questionIndex}`"
          >
            <button
              :id="`${item.id}-button`"
              type="button"
              :aria-controls="`${item.id}-content`"
              class="faq__group-questions"
              :aria-expanded="item.expanded"
              :data-inbound-analytics="data.data_inbound_analytics"
              :data-toggle-group="group.header"
              :data-ga-toggle="item.expanded ? 'collapse' : 'expand'"
              @click="toggleQuestion(groupIndex, questionIndex)"
            >
              <span :id="item.id" class="anchor-target"></span>
              <SlpTypography
                :ref="item.id"
                :data-anchor-index="`${groupIndex},${questionIndex}`"
                tag="h4"
                variant="heading5"
                >{{ item.question }}</SlpTypography
              >
              <SlpIcon
                v-if="item.expanded"
                class="faq__expand-icon"
                name="dash"
                variant="product"
                alt="Dash Icon"
              />
              <SlpIcon
                v-else
                class="faq__expand-icon"
                name="plus"
                variant="product"
                alt="Plus Icon"
              />
            </button>
            <div
              v-if="item.expanded"
              :id="`${item.id}-content`"
              role="region"
              :aria-labelledby="`${item.id}-button`"
              class="faq__content"
            >
              <div class="faq__answer" v-html="$md.render(item.answer)" />
              <router-link :to="{ path: '', hash: item.id }" data-test="ty">
                <SlpIcon
                  class="anchor-icon"
                  name="anchor"
                  variant="marketing"
                  slp-color="primary-200"
                  alt="Anchor Icon"
                />
              </router-link>
            </div>
          </div>
        </div>
      </div>
      <button type="button" class="view-more" @click="toggleSectionVisibility">
        <SlpTypography
          tag="span"
          variant="body2-bold"
          class="slp-flex slp-justify-content-center slp-color-primary-200"
          >{{ groupsData.visible ? 'View Less' : 'View More' }}

          <SlpIcon
            class="view-more-icon"
            :name="groupsData.visible ? 'chevron-lg-up' : 'chevron-lg-down'"
            variant="product"
            slp-color="primary-200"
            alt="Chevron Icon"
          />
        </SlpTypography>
      </button>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
$visible-height: 70px;

.slp-faq {
  display: flex;
  justify-content: space-between;
  padding: $spacing-96 $spacing-16 !important;
  flex-direction: column;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }
}

.anchor-target {
  bottom: 100%;
  display: block;
  height: 75px;
  position: absolute;
  visibility: hidden;
  width: 100%;
}

.faq {
  max-width: 100%;
  @media (min-width: $breakpoint-lg) {
    max-width: 60%;
    min-width: 60%;
  }
  &__title {
    padding-right: $spacing-48;
    margin-bottom: $spacing-32;
    text-align: left;
    h2 {
      display: inline-block;
    }
  }

  .view-more {
    margin-top: $spacing-32;
    text-align: center;
    cursor: pointer;
    border: none;
    width: 100%;
  }

  .group-control {
    color: $color-text-link-100;
    cursor: pointer;
    text-decoration: underline;
    font-weight: 600;
    white-space: nowrap;
  }

  &--double-column {
    @media (min-width: 1024px) {
      column-count: 2;
    }
  }

  &__container {
    margin: 0 0 -2px -1px;
  }

  &__wrapper {
    display: inline-block;
    width: 100%;

    .action {
      border: none;
    }
  }
  &__group-header {
    border-top: 1px solid $color-surface-500;
  }

  &__group-header,
  &__group-questions {
    padding: $spacing-16 0;
    display: flex;
    background: transparent;
    justify-content: space-between;
    border-bottom: 1px solid $color-surface-300;
    align-items: center;
    position: relative;
    min-height: $visible-height;
    color: $color-primary-200;

    img {
      min-width: 1rem;
    }
  }

  &__group-questions {
    cursor: pointer;
    width: 100%;
    text-align: left;
    font-size: inherit;
    font-weight: inherit;
    border-top: none;
    border-left: none;
    border-right: none;
  }

  &__header {
    font-size: 24px;
    line-height: 30px;
    @media (min-width: $breakpoint-lg) {
      font-size: 32px;
      line-height: 36px;
    }
  }

  &__content {
    padding: 1rem 0px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    @media (min-width: $breakpoint-lg) {
      padding: 30px 0px;
    }
  }

  .view-more-icon {
    margin-left: $spacing-16;
  }

  &__expand-icon {
    object-fit: scale-down;
    margin-left: $spacing-16;
  }

  .anchor-icon {
    cursor: pointer;
    margin-left: $spacing-16;
  }

  &__question {
    font-size: 19px;
    line-height: 24px;
    margin-bottom: 8px;

    @media (min-width: $breakpoint-lg) {
      font-size: 23px;
      line-height: 28px;
    }
  }

  &__answer {
    margin-bottom: 24px;

    &:deep {
      ul {
        list-style-type: disc;
        list-style-position: inside;
        padding-left: 1.3em;
        text-indent: -1.3em;
      }
      li {
        margin-bottom: $spacing-8;
      }
      p:not(:last-of-type),
      ul:not(:last-of-type),
      ol:not(:last-of-type) {
        margin-bottom: $spacing-16;
      }
    }

    @media (min-width: $breakpoint-lg) {
      line-height: 24px;
      font-size: 16px;
    }
  }
}
</style>
